# frozen_string_literal: true

require 'nokogiri'

module Jekyll
  # Monkey-patches Jekyll documents so their contents can be parsed
  module Nokogiri
    def self.included(base)
      base.class_eval do
        # Parses content as HTML
        #
        # @return [Nokogiri::HTML5::DocumentFragment]
        def to_html
          @to_html ||= ::Nokogiri::HTML5.fragment(content)
        end

        # Returns original content if we haven't modified it
        #
        # @return [String]
        def content
          return @content unless defined? @to_html

          to_html.to_s
        end
      end
    end
  end
end
